package edu.wpi.banmqp.basestation;

import android.bluetooth.BluetoothDevice;

/**
 * Wrapper for a BluetoothDevice to allow additional functionality
 * 
 * 
 */
public class BTDevice {

	/** The bluetooth device. */
	BluetoothDevice bd;

	/**
	 * Instantiates a new BT device.
	 * 
	 * @param bd the BluetoothDevice to wrap
	 */
	public BTDevice(BluetoothDevice bd) {
		this.bd = bd;

	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see java.lang.Object#toString()
	 */
	@Override
	public String toString() {
		return bd.getName() + " " + bd.getAddress();
	}

	/**
	 * Gets the address.
	 * 
	 * @return the address
	 */
	public String getAddress() {
		return bd.getAddress();
	}

}
