/**
 * 
 */
package edu.wpi.banmqp.basestation;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.Map.Entry;
import java.util.Observable;
import java.util.Observer;

import android.annotation.SuppressLint;
import android.app.Activity;
import android.graphics.Color;
import android.os.Bundle;
import android.os.Handler;
import android.os.Message;
import android.util.Log;

import com.androidplot.Plot;
import com.androidplot.xy.LineAndPointFormatter;
import com.androidplot.xy.PointLabelFormatter;
import com.androidplot.xy.XYPlot;
import com.androidplot.xy.XYSeries;
import com.androidplot.xy.XYStepMode;
//import com.androidplot.series.XYSeries;

/**
 * @author John
 *
 */
@SuppressLint("UseSparseArrays")
public class PlotActivity extends Activity
{
	private static ArrayList<Integer> indexes = new ArrayList<Integer>();
	private static boolean created, onCreateComplete, lablesSet = false;
	static HashMap<Integer, PlotSource> plotSources;
	private static int redrawCount = 0;
	private static PointLabelFormatter plf;
	private static LineAndPointFormatter lpf;
	private final static Handler graphHandler = new Handler() {
		public void handleMessage(Message msg) {
			if(!onCreateComplete){
				return;
			}
			if(plotSources == null){
				plotSources = new HashMap<Integer, PlotSource>();
			}
			//if(!created){
			//	return;
			//}
			Bundle b = msg.getData();
			int index = b.getInt("index");
			int numValues = b.getInt("numValues");
			double data = b.getDouble("data");
			String deviceName = b.getString("deviceName");
			String units = b.getString("units");
			String legendTitle = b.getString("legendTitle");

			if (plotSources.size() < numValues) {
				Log.i("HANDLER", "plotSources is less than numValues");
				created = false;
			}

			if (!created && plotSources.size() == numValues) {
				Log.i("HANDLER", "plotSources equals numValues, creating graph");
				createGraph();
				created = true;
				dynamicPlot.setTitle(deviceName);
				dynamicPlot.setRangeLabel(units);
			}

			if(!created && !indexes.contains(index)){
				PlotSource p = new PlotSource();
				plotSources.put(index, p);
				indexes.add(index);
			}

			if(plotSources.get(index) == null){
				PlotSource p = new PlotSource();
				plotSources.put(index, p);
				//Create lines on graph here			

			} else {
				plotSources.get(index).pushValue(data);
				plotSources.get(index).setTitle(legendTitle);
			}

			//plotSources.get(index).pushValue(data);
			if (created) {
				//dynamicPlot.clear();
				if(++redrawCount == 50){
					Log.i("HANDLER", "Attempting to redraw");
					dynamicPlot.redraw();
					redrawCount = 0;
				}
			}


			/*
			if(!created && !indexes.contains(index)){
				plotSources.put(index, new PlotSource());
				indexes.add(index);
			}
			else if(!created){
				createGraph();
				created = true;
			}
			if(plotSources.get(index) == null){
				PlotSource p = new PlotSource();
				plotSources.put(index, p);
				//Create lines on graph here			

			}
			plotSources.get(index).pushValue(data);
			if (dynamicPlot != null) {
				dynamicPlot.clear();
				dynamicPlot.redraw();
			}
			 */
		}



	};

	public static Handler getHandler() {
		return graphHandler;
	}


	// redraws a plot whenever an update is received:
	private class MyPlotUpdater implements Observer {
		Plot plot;

		public MyPlotUpdater(Plot plot) {
			this.plot = plot;
		}

		@Override
		public void update(Observable o, Object arg) {
			plot.redraw();
		}
	}

	private static XYPlot dynamicPlot;
	private MyPlotUpdater plotUpdater;
	//SampleDynamicXYDatasource data;
	PlotSource data;
	private Thread myThread;

	@Override
	public void onCreate(Bundle savedInstanceState) {

		// android boilerplate stuff
		super.onCreate(savedInstanceState);
		setContentView(R.layout.activity_plot);

		// get handles to our View defined in layout.xml:
		dynamicPlot = (XYPlot) findViewById(R.id.PlotActivity);

		plotSources = new HashMap<Integer, PlotSource>();
		plotUpdater = new MyPlotUpdater(dynamicPlot);
		
		onCreateComplete = true;

		// only display whole numbers in domain labels
		//dynamicPlot.getGraphWidget().setDomainValueFormat(new DecimalFormat("0"));

		// getInstance and position datasets:
		//data = new SampleDynamicXYDatasource();
		//data = new PlotSource();

		//createGraph();


		// hook up the plotUpdater to the data model:
		//data.addObserver(plotUpdater);

		//dynamicPlot.setDomainStepMode(XYStepMode.SUBDIVIDE);
		//dynamicPlot.setDomainStepValue(plotSources.);

		// thin out domain/range tick labels so they dont overlap each other:
		//dynamicPlot.setTicksPerDomainLabel(5);
		//dynamicPlot.setTicksPerRangeLabel(3);

		// uncomment this line to freeze the range boundaries:
		//dynamicPlot.setRangeBoundaries(-100, 100, BoundaryMode.FIXED);

	}

	private synchronized static void createGraph() {
		int plotCount = 0;

		Log.i("CRTGRPH", "Creating Graph with " + plotSources.size() + " lines");
		for(Integer i : plotSources.keySet()) {
			Log.i("ONCRT", "Created Graph ####################################");
			//Integer indx = entry.getKey();
			PlotSource ps = plotSources.get(i);
			int color = Color.rgb(0, 0, 255);
			if (plotCount == 1) {
				color = Color.rgb(0, 255, 0);
			}
			if (plotCount == 2) {
				color = Color.rgb(255, 0, 0);
			}
			//else{
			//	break;
			//}
			plf = (PointLabelFormatter) null;
			lpf = new LineAndPointFormatter(color, Color.TRANSPARENT, /*body*/ Color.rgb(0, 0, 0), /*(PointLabelFormatter) null*/ plf);
			lpf.getFillPaint().setAlpha(0);
			dynamicPlot.addSeries(ps, lpf);
			dynamicPlot.getGraphWidget().getBackgroundPaint().setColor(Color.BLACK);
			dynamicPlot.getGraphWidget().getGridBackgroundPaint().setColor(Color.BLACK);
			
			
			//dynamicPlot.
			dynamicPlot.setDomainStepMode(XYStepMode.SUBDIVIDE);
			dynamicPlot.setDomainStepValue(ps.size());

			//dynamicPlot.setTicksPerDomainLabel(Integer.MAX_VALUE);
			//dynamicPlot.setTicksPerRangeLabel(Integer.MAX_VALUE);
			dynamicPlot.setTicksPerDomainLabel(1);
			dynamicPlot.setTicksPerRangeLabel(100);

			plotCount++;

		}
	}

	@Override
	public void onResume() {
		// kick off the data generating thread:
		//myThread = new Thread(data);
		//myThread.start();
		super.onResume();
	}

	@Override
	public void onPause() {
		//data.stopThread();
		super.onPause();
	}


}
