package edu.wpi.banmqp.basestation;

import java.util.ArrayList;

import android.util.Log;

import com.androidplot.xy.XYSeries;

    class PlotSource implements XYSeries {

		private ArrayList<Double> data;
		private String title;
		private final int maxSize = 500;

		public PlotSource(String title) {
    		this.data = new ArrayList<Double>();
    		this.title = title;
    	}
    	
    	public PlotSource(){
    		this.title = "";
    		this.data = new ArrayList<Double>();
    	}
    	
    	public void setTitle(String title) {
    		this.title = title;
    	}
    	
    	public void pushValue(double val) {
    		data.add(0, val);
    		if (data.size() > maxSize) {
    			data.remove(maxSize);
    		}
    		
    	}

		@Override
		public String getTitle() {
			return title;
			//return title;
		}

		@Override
		public Number getX(int index) {
			Log.i("PLOTSRC", "Got X: " + index);
			return index;
		}

		@Override
		public Number getY(int index) {
			Log.i("PLOTSRC", "Got Y: " + data.get(index));
			return data.get(index);
		}

		@Override
		public int size() {
			return data.size();
		}
    	
    	
    	
    }