package edu.wpi.banmqp.basestation;

import java.util.Set;

import android.app.Activity;
import android.app.ListActivity;
import android.bluetooth.BluetoothAdapter;
import android.bluetooth.BluetoothDevice;
import android.content.Intent;
import android.os.Bundle;
import android.support.v4.app.NavUtils;
import android.view.Menu;
import android.view.MenuItem;
import android.view.View;
import android.widget.ArrayAdapter;
import android.widget.ListView;
import edu.wpi.banmqp.util.BANLog;

// TODO: Auto-generated Javadoc
/**
 * The Class SettingsActivity.
 */
public class SettingsActivity extends ListActivity {

	Intent intent;


	/*
	 * (non-Javadoc)
	 * 
	 * @see android.app.Activity#onCreate(android.os.Bundle)
	 */
	@Override
	protected void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		intent = new Intent();
		setContentView(R.layout.activity_settings);
		// Show the Up button in the action bar.
		setupActionBar();

		// Put stuff in menu
		ListView lv = (ListView) findViewById(android.R.id.list);
		Set<BluetoothDevice> pairedDevices = BluetoothAdapter
				.getDefaultAdapter().getBondedDevices();
		ArrayAdapter<BTDevice> aa = new ArrayAdapter<BTDevice>(
				getApplicationContext(), android.R.layout.simple_list_item_1);
		if (pairedDevices.size() > 0) {
			for (BluetoothDevice device : pairedDevices) {
				aa.add(new BTDevice(device));
			}
		}


		lv.setAdapter(aa);
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see android.app.ListActivity#onListItemClick(android.widget.ListView,
	 * android.view.View, int, long)
	 */
	@Override
	protected void onListItemClick(ListView l, View v, int position, long id) {
		BTDevice clickedDevice = (BTDevice) l.getItemAtPosition(position);
		BANLog.d("SETTINGS", "Clicked on device " + clickedDevice.toString());
		intent.putExtra("BTID", clickedDevice.getAddress());
		BANLog.d("SETTINGS", "BTADDR: " + clickedDevice.getAddress());
		setResult(Activity.RESULT_OK, intent);
		finish();

	}


	private void setupActionBar() {

		getActionBar().setDisplayHomeAsUpEnabled(true);

	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see android.app.Activity#onCreateOptionsMenu(android.view.Menu)
	 */
	@Override
	public boolean onCreateOptionsMenu(Menu menu) {
		// Inflate the menu; this adds items to the action bar if it is present.
		getMenuInflater().inflate(R.menu.settings, menu);
		return true;
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see android.app.Activity#onOptionsItemSelected(android.view.MenuItem)
	 */
	@Override
	public boolean onOptionsItemSelected(MenuItem item) {
		switch (item.getItemId()) {
		case android.R.id.home:
			// This ID represents the Home or Up button. In the case of this
			// activity, the Up button is shown. Use NavUtils to allow users
			// to navigate up one level in the application structure. For
			// more details, see the Navigation pattern on Android Design:
			//
			// http://developer.android.com/design/patterns/navigation.html#up-vs-back
			//
			NavUtils.navigateUpFromSameTask(this);
			return true;
		}
		return super.onOptionsItemSelected(item);
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see android.app.ListActivity#onDestroy()
	 */
	@Override
	public void onDestroy() {
		NavUtils.navigateUpFromSameTask(this);
		super.onDestroy();
	}

}
