package edu.wpi.banmqp.shimmer;

import android.os.Handler;

import edu.wpi.banmqp.shimmer.sensor.ISensor;

// TODO: Auto-generated Javadoc
/**
 * The Interface IShimmer.
 */
public interface IShimmer {

	/**
	 * Gets the data.
	 * 
	 * @param numBytesToGet the num bytes to get
	 * @return the data
	 */
	public byte[] getData(int numBytesToGet);

	/**
	 * Bytes availible.
	 * 
	 * @return the int
	 */
	public int bytesAvailible();

	/**
	 * Start streaming.
	 */
	public void startStreaming();

	/**
	 * Stop streaming.
	 */
	public void stopStreaming();

	/**
	 * Gets the bluetooth addr.
	 * 
	 * @return the bluetooth addr
	 */
	public String getBluetoothAddr();

	/**
	 * Checks if is connected.
	 * 
	 * @return true, if is connected
	 */
	public boolean isConnected();

	/**
	 * @return an array containing the integer ID's for the sensors for this
	 *         mote
	 */
	public Integer[] getSensorIDs();

	/**
	 * @return an array containing the sensors for this mote
	 */
	public ISensor[] getSensors();

	public ISensor getSensorById(int id);

	/**
	 * @return an array containing the sensor names for this mote
	 */
	public String[] getSensorNames();

	/**
	 * Processes the next packet in the inputstream
	 * 
	 * @return A byte[] containing mote data if the packet contained mote data,
	 *         null otherwise
	 */
	public void processPacket(Handler h);

	public void disconnect();

	public void sendSensorInquiry();

	public void sendCommandInquiry(int sensorID);

	public void sendCommandParamsInquiry(int SensorID, int commandID);

	public void sendCommandReturnsInquiry(int sensorID, int commandID);

	public void sendDataInquiry(int sensorID);

	public void sendSensorInquiry(boolean cascade);
	
	public void sendCustomCommand(int sensorID, int commandID, byte[] values);
	
	public void sendMoteData();
	
	public boolean clearToSend();
	
	public boolean waitingToSend();
	
	public boolean sendNextMsg();
	
	public boolean isStreaming();

	public void resumeStreaming(boolean b);

	

}
