package edu.wpi.banmqp.shimmer;

import java.util.Random;

import android.os.Handler;

import edu.wpi.banmqp.shimmer.sensor.ISensor;

// TODO: Auto-generated Javadoc
/**
 * The Class MockShimmer.
 */
public class MockShimmer implements IShimmer {
	
	/** The streaming. */
	boolean streaming;
	
	/** The r. */
	Random r;

	/**
	 * Instantiates a new mock shimmer.
	 */
	public MockShimmer() {
		this.r = new Random();
		streaming = false;
		
	}

	/* (non-Javadoc)
	 * @see edu.wpi.banmqp.shimmer.IShimmer#getData(int)
	 */
	@Override
	public byte[] getData(int numBytesToGet) {
		if(!streaming){
			return null;
		}
		byte[] mByteArray = new byte[numBytesToGet];
		r.nextBytes(mByteArray);
		return mByteArray;
	}

	/* (non-Javadoc)
	 * @see edu.wpi.banmqp.shimmer.IShimmer#bytesAvailible()
	 */
	@Override
	public int bytesAvailible() {
		if(!streaming){
			return 0;
		}
		return Integer.MAX_VALUE;
	}

	/* (non-Javadoc)
	 * @see edu.wpi.banmqp.shimmer.IShimmer#startStreaming()
	 */
	@Override
	public void startStreaming() {
		streaming = true;
		
	}

	/* (non-Javadoc)
	 * @see edu.wpi.banmqp.shimmer.IShimmer#stopStreaming()
	 */
	@Override
	public void stopStreaming() {
		streaming = false;
		
	}

	/* (non-Javadoc)
	 * @see edu.wpi.banmqp.shimmer.IShimmer#getBluetoothAddr()
	 */
	@Override
	public String getBluetoothAddr() {
		return "MOCK SHIMMER DEVICE";
	}

	/* (non-Javadoc)
	 * @see edu.wpi.banmqp.shimmer.IShimmer#isConnected()
	 */
	@Override
	public boolean isConnected() {
		return true;
	}

	/* (non-Javadoc)
	 * @see edu.wpi.banmqp.shimmer.IShimmer#sendBytes(byte[])
	 */
	public boolean sendBytes(byte[] bytes) {
		return false;
	}

	@Override
	public Integer[] getSensorIDs() {
		// TODO Auto-generated method stub
		return null;
	}

	@Override
	public ISensor[] getSensors() {
		// TODO Auto-generated method stub
		return null;
	}

	@Override
	public String[] getSensorNames() {
		// TODO Auto-generated method stub
		return null;
	}




	@Override
	public void disconnect() {
		// TODO Auto-generated method stub
		
	}

	@Override
	public void processPacket(Handler h) {
		// TODO Auto-generated method stub
		return;
	}

	@Override
	public ISensor getSensorById(int id) {
		// TODO Auto-generated method stub
		return null;
	}

	@Override
	public void sendSensorInquiry() {
		// TODO Auto-generated method stub
		
	}

	@Override
	public void sendCommandInquiry(int sensorID) {
		// TODO Auto-generated method stub
		
	}

	@Override
	public void sendCommandParamsInquiry(int SensorID, int commandID) {
		// TODO Auto-generated method stub
		
	}

	@Override
	public void sendCommandReturnsInquiry(int sensorID, int commandID) {
		// TODO Auto-generated method stub
		
	}

	@Override
	public void sendDataInquiry(int sensorID) {
		// TODO Auto-generated method stub
		
	}

	@Override
	public void sendSensorInquiry(boolean cascade) {
		// TODO Auto-generated method stub
		
	}

	@Override
	public void sendMoteData() {
		// TODO Auto-generated method stub
		
	}

	@Override
	public boolean clearToSend() {
		// TODO Auto-generated method stub
		return false;
	}

	@Override
	public boolean waitingToSend() {
		// TODO Auto-generated method stub
		return false;
	}

	@Override
	public boolean sendNextMsg() {
		// TODO Auto-generated method stub
		return false;
	}

	@Override
	public void sendCustomCommand(int sensorID, int commandID, byte[] values) {
		// TODO Auto-generated method stub
		
	}

	@Override
	public boolean isStreaming() {
		// TODO Auto-generated method stub
		return false;
	}

	@Override
	public void resumeStreaming(boolean b) {
		// TODO Auto-generated method stub
		
	}





}
