package edu.wpi.banmqp.shimmer.commands.learned;

import java.util.ArrayList;

import edu.wpi.banmqp.shimmer.sensor.ISensor;

public class LearnedCommand implements ILearnedCommand {
	
	private int ID;
	private String name;
	private ArrayList<ParamMapping> paramMapping = null;
	private ArrayList<ReturnMapping> rm = null;
	private ISensor sensor;
	private ArrayList<byte[]> paramBytes;
	
	public LearnedCommand(ISensor sensor, int ID, String name){
		this.sensor = sensor;
		this.ID = ID;
		this.name = name;
		paramBytes = new ArrayList<byte[]>();
	}

	@Override
	public int getID() {
		return ID;
	}

	@Override
	public String getName() {
		return name;
	}

	@Override
	public ArrayList<ParamMapping> getParams() {
		return paramMapping;
	}

	@Override
	public void setParams(ArrayList<ParamMapping> paramMapping) {
		this.paramMapping = paramMapping;
		
	}

	@Override
	public ArrayList<ReturnMapping> getReturnMapping() {
		return rm;
	}

	@Override
	public void setReturnMapping(ArrayList<ReturnMapping> r) {
		rm = r;
		
	}
	
	@Override
	public String toString(){
		return getName();
	}

	@Override
	public ISensor getSensor() {
		return sensor;
	}

	@Override
	public ArrayList<byte[]> getParamBytes() {
		return paramBytes;
	}

}
