package edu.wpi.banmqp.util;

import java.util.ArrayList;

import android.util.Log;

public final class BANLog {
	private static ArrayList<String> logEntries;
	private static boolean DEBUG =  false;

	/**
	 * @return the logEntries
	 */
	public static ArrayList<String> getLogEntries() {
		return logEntries;
	}

	private BANLog(){
		logEntries = new ArrayList<String>();
	}

	private static void addLog(String type, String tag, String msg){
		if(logEntries == null){
			logEntries = new ArrayList<String>();
		}
		logEntries.add(type + ": " + tag + ": " + msg);
		// Stop this from just using up memory forever
		if(logEntries.size() > 100){
			logEntries.remove(0);
		}
	}

	public static void d(String tag, String msg){
		if(DEBUG){
			Log.i(tag, msg);
			addLog("I", tag, msg);
		}
	}

	public static void e(String tag, String msg){
		if(DEBUG){
			Log.e(tag, msg);
			addLog("E",tag, msg);
		}
	}

	// Don't log verbose msgs to screen, it would get way too confusing
	public static void v(String tag, String msg){
		if(DEBUG){
			Log.v(tag, msg);
		}
	}

}
